/*****************************************************************************/
/*
                                  Control.h
*/
/*****************************************************************************/

#ifndef CONTROL_H_LOADED
#define CONTROL_H_LOADED 1

#include "wasd.h"

#define CONTROL_ABORT                 "ABORT"  /* backward comptability only */
#define CONTROL_AUTH_LOAD             "AUTH=LOAD"
#define CONTROL_AUTH_PURGE            "AUTH=PURGE"
#define CONTROL_CACHE_ON              "CACHE=ON"
#define CONTROL_CACHE_OFF             "CACHE=OFF"
#define CONTROL_CACHE_PURGE           "CACHE=PURGE"
#define CONTROL_DCL_DELETE            "DCL=DELETE"
#define CONTROL_DCL_PURGE             "DCL=PURGE"
#define CONTROL_DECNET_PURGE          "DECNET=PURGE"
#define CONTROL_DECNET_DISCONNECT     "DECNET=DISCONNECT"
#define CONTROL_EXIT                  "EXIT"
#define CONTROL_EXIT_NOW              "EXIT=NOW"
#define CONTROL_LIST                  "LIST"   /* command-line info only */
#define CONTROL_LOG_OPEN              "LOG=OPEN"
#define CONTROL_LOG_CLOSE             "LOG=CLOSE"
#define CONTROL_LOG_FLUSH             "LOG=FLUSH"
#define CONTROL_LOG_OPEN_AS           "LOG=OPEN="
#define CONTROL_LOG_REOPEN            "LOG=REOPEN"
#define CONTROL_LOG_REOPEN_AS         "LOG=REOPEN="
#define CONTROL_LOG_FORMAT_AS         "LOG=FORMAT="
#define CONTROL_LOG_PERIOD_AS         "LOG=PERIOD="
#define CONTROL_MAP                   "MAP"
#define CONTROL_PROXY_ON              "PROXY=ON"
#define CONTROL_PROXY_OFF             "PROXY=OFF"
#define CONTROL_PROXY_PURGE_REACTIVE  "PROXY=PURGE=REACTIVE"
#define CONTROL_PROXY_PURGE_ROUTINE   "PROXY=PURGE=ROUTINE"
#define CONTROL_PROXY_PURGE_HOST      "PROXY=PURGE=HOST"
#define CONTROL_RESTART               "RESTART"
#define CONTROL_RESTART_NOW           "RESTART=NOW"
#define CONTROL_ZERO                  "ZERO"

#define CONTROL_DELAY_EXIT            0x1
#define CONTROL_DELAY_RESTART         0x2
#define CONTROL_DELAY_DO              0x4

/**************/
/* structures */
/**************/

#ifdef __ALPHA
#   pragma member_alignment __save
#   pragma member_alignment
#endif

#ifdef __ALPHA
#   pragma member_alignment __restore
#endif

/***********************/
/* function prototypes */
/***********************/

int ControlAllHttpd (int);
ControlAllHttpdAst ();
ControlDelay (int);
char* ControlAllHttpdList (char*, int*);
char* ControlDoAllLock (char*);
ControlDoAllLockAst ();
int ControlAllCommand (char*);
ControlCommandTimeoutAst ();
int ControlHttpd ();
ControlMbxReadAst ();
ControlMessage (char*);
ControlMbxWriteAst ();

#endif /* CONTROL_H_LOADED */

/*****************************************************************************/
