/*****************************************************************************/
/*
                                  DECnet.h
*/
/*****************************************************************************/

#ifndef DECNET_H_LOADED
#define DECNET_H_LOADED 1

#include "wasd.h"

/**************/
/* structures */
/**************/

struct DECnetConnectStruct
{
   struct  /* allows a list of these to be constructed */
           ListEntryStruct  DclListEntry;

   boolean  /* when the current request is finished disconnect from the task */
            IsMarkedForDisconnect,
            /* task has indicated it is capable of reusing the connection */
            ReuseConnection;

   unsigned short  /* zero if no current channel, or channel number */
                  DECnetChannel;

   int  /* number of minutes still to live */
        LifeTimeCount,
        /* number of times it has been reused */
        ReUsageCount,
        /* number of times it has been used */
        UsageCount;

   char  /* node::"task=whatever" */
         ConnectString [64];

   unsigned long  /* last used binary time ;^) */
                  LastUsedBinaryTime[2];

   /* NULL if no associated request, or pointer to assosciated request */
   struct RequestStruct  *RequestPtr;
};

struct DECnetTaskStruct
{
   boolean  /* */
            AddNewline,
            /* an  <DNETCGI> was set by the script */
            OsuDnetCgi,
            /* an  <DNETRECMODE> was set by the script */
            OsuDnetRecMode,
            /* the script generated some output */
            ScriptResponded;
    

   int  /* */
        CgiDialogState,
        /* */
        CgiEofLength,
        /* */
        ConnectStringLength,
        /* */
        ContentCount,
        /* */
        ContentCountZero,
        /* */
        FindScriptCount,
        /* */
        FindScriptLength,
        /* */
        FindScriptTotalLength,
        /* */
        QueuedDECnetIO,
        /* */
        OsuDialogState,
        /* */
        ScriptType;

   unsigned short  DECnetChannel,
                   DECnetMbxChannel;

   char  /* */
         *ContentPtr,
         /* */
         *FindScriptTypePtr,
         /* current position when sending request header */
         *OsuDnetHdrPtr,
         /* */
         *RunTimePtr,
         /* */
         *ScriptPtr;

   char  /* unsique string used to indicate end of script output */
         CgiEof [48],
         /* node::"task=whatever" */
         ConnectString [64],
         /* buffer for DCL commands */
         DclCommand [256],
         /* VMS file script name used for searching */
         FindScript [256],
         /* VMS file script name */
         MappedScript [256],
         /* DCL required to execute the script */
         CgiScriptDcl [256],
         /* the above command being set up as a foreign verb, if necessary */
         CgiScriptForeignVerb [256];

   struct AnIOsb  DECnetConnectIOsb,
                  DECnetReadIOsb,
                  DECnetWriteIOsb;

   /* pointer a request using this DCL task structure */
   struct RequestStruct  *RequestPtr;

   /* pointer to the DECnet connection */
   struct DECnetConnectStruct  *cnptr;

   /* pointer to function, used for specifying the next task */
   void (*NextTaskFunction)(struct RequestStruct*);
};

/***********************/
/* function prototypes */
/***********************/

DECnetCgiDialog (struct RequestStruct*);
DECnetConnect (struct RequestStruct*, void*, char*);
DECnetConnectAst (struct RequestStruct*);
DECnetDisconnectTask (struct DECnetTaskStruct*);
DECnetEnd (struct RequestStruct*);
DECnetOsuCgi (struct RequestStruct*, char*);
DECnetOsuDialog (struct RequestStruct*);
DECnetOsuDnetId (struct RequestStruct*, struct DECnetTaskStruct*, boolean);
DECnetOsuDnetXlate (struct RequestStruct*, struct DECnetTaskStruct*, char*);
DECnetRead (struct RequestStruct*);
DECnetReadAst (struct RequestStruct*);
DECnetWrite (struct RequestStruct*, char*, int);
DECnetWriteAst (struct RequestStruct*);
DECnetWriteRequest (struct RequestStruct*);
DECnetWriteRequestAst (struct RequestStruct*);

#endif /* DECNET_H_LOADED */

/*****************************************************************************/

