/*****************************************************************************/
/*
                                   Net.h
*/
/*****************************************************************************/

#ifndef NET_H_LOADED
#define NET_H_LOADED 1

#include "wasd.h"

/* output character encoding */
#define NET_WRITE_BUFFERED_NONE     0
#define NET_WRITE_BUFFERED_HTMLESC  1
#define NET_WRITE_BUFFERED_URLENC   2

/**************/
/* structures */
/**************/

/***********************/
/* function prototypes */
/***********************/

NetAccept (struct ServiceStruct*);
NetAcceptAst (struct ServiceStruct*);
NetAccessDenied (unsigned short, char*, char*);
NetBreakSocket (struct RequestStruct*);
NetBreakSocketAst (struct RequestStruct*);
NetClientAddressLookup (struct ServiceStruct*);
NetCreateService ();
NetWriteDirect (unsigned short, char*, int);
NetDummyRead (unsigned short);
NetDummyReadAst (unsigned short);
NetGetServerHostName ();
NetHostNameLookup (char*, int, char*, char*, char*, char*, int*);
NetParseHostString (char*, char*, int, int*);
unsigned long NetHostNameHash (char*);
unsigned long NetHostPortHash (char*, char*);
NetListen ();
NetResponseHeaderAst (struct RequestStruct*);
NetServerShutdown (unsigned short);
char* NetServiceNextHostPort (unsigned long*);
int NetServiceReportConfig (struct RequestStruct*, struct ConfigStruct*);
int NetServiceReportStats (struct RequestStruct*);
NetServiceZeroAccounting ();
NetTooBusy (unsigned short, char*, char*);
boolean NetServiceConfigured (char*);
NetSetService ();
NetCloseSocket (struct RequestStruct*);
int NetRead (struct RequestStruct*, void*, char*, int);
int NetReadRaw (struct RequestStruct*, void*, char*, int);
NetReadRawAst (struct RequestStruct*);
boolean NetVirtualService (struct RequestStruct*);
boolean NetThisVirtualService (char*, char*);

int NetWrite (struct RequestStruct*, void*, char*, int);
int NetWriteBuffered (struct RequestStruct*, void*, char*, int);
int NetWriteRaw (struct RequestStruct*, void*, char*, int);
NetWriteRawAst (struct RequestStruct*);

/* vector print to network buffer */
#define NetWriteFaol(rq,fs,vp) WriteFormatted(rq,NULL,0,NULL,fs,vp)
/* for naming consistency */
#define NetWriteFao WriteFaoNet

/* definition to flush the buffer only if there is more than a buffer-full */
#define NetWritePartFlush(rq,ast) NetWriteBuffered(rq,ast,NULL,-1)

/* to flush buffered contents completely */
#define NetWriteFullFlush(rq,ast) NetWriteBuffered(rq,ast,NULL,0)

/* initialize the buffer */
#define NetWriteInit(rq) NetWriteBuffered(rq,NULL,NULL,0)

#endif /* NET_H_LOADED */

/*****************************************************************************/

                                 
